Unit DewTest;
Interface
Uses
  WinTypes,
  WinProcs,
  Win31,
  oWindows,
  oDialogs,
  DynLink,
  DialogWn,
  ooDEWCC,
  DewData;

{-DEW demo}
const
  {control IDs}
  id_LastName  = 101;
  id_FirstName = 102;
  id_Company   = 103;
  id_Address   = 104;
  id_City      = 105;
  id_State     = 106;
  id_ZipCode   = 107;
  id_HomePhone = 108;
  id_WorkPhone = 109;
  id_HelpLine  = 200;

type
  {data type of transfer buffer}
  CustomerData = record
    LastName  : array[0..30] of Char;
    FirstName : array[0..30] of Char;
    Company   : array[0..30] of Char;
    Address   : array[0..45] of Char;
    City      : array[0..30] of Char;
    State     : array[0..02] of Char;
    ZipCode   : array[0..10] of Char;
    HomePhone : array[0..14] of Char;
    WorkPhone : array[0..14] of Char;
  end;

  PCustomer = ^TCustomer;
  TCustomer = object(TEntryScreen)
    Data: CustomerData;
    HelpLine : PStatic;  {help line control object}
    constructor Init(AParent : PWindowsObject; aName: pChar);
    procedure dwmPreEdit(var Msg : TMessage); virtual wm_First+dwm_PreEdit;
    procedure dwmHelp(var Msg : TMessage); virtual wm_First+dwm_Help;
  end;

Implementation

{TCustomer}
  constructor TCustomer.Init(AParent : PWindowsObject; aName: pChar);
  var
    CP : PControl;
  begin
    FillChar(Data, SizeOf(Data), 0);
    Inherited Init(AParent, 'CUSTOMER', Data);

    {create entry field control objects}
    CP := New(PPictureField, InitResource(@Self, id_LastName));
    CP := New(pPictureField, InitResource(@Self, id_FirstName));
    CP := New(PPictureField, InitResource(@Self, id_Company));
    CP := New(PPictureField, InitResource(@Self, id_Address));
    CP := New(PPictureField, InitResource(@Self, id_City));
    CP := New(PPictureField, InitResource(@Self, id_State));
    CP := New(PPictureField, InitResource(@Self, id_ZipCode));
    CP := New(PPictureField, InitResource(@Self, id_HomePhone));
    CP := New(PPictureField, InitResource(@Self, id_WorkPhone));

    {create push button control objects}
    CP := New(PwButton,      InitResource(@Self, id_OK));
    CP := New(PwButton,      InitResource(@Self, id_Cancel));

    {create control object for static text control used to display help}
    HelpLine := New(PStatic, InitResource(@Self, id_HelpLine, 80));
    HelpLine^.DisableTransfer;
  end;

  procedure TCustomer.dwmPreEdit(var Msg : TMessage);
  var
    P : PChar;
  begin
    case Msg.wParam of
      id_LastName  : P := 'Enter customer''s last name';
      id_FirstName : P := 'Enter customer''s first name';
      id_Company   : P := 'Enter name of customer''s company';
      id_Address   : P := 'Enter customer''s street address';
      id_City      : P := 'Enter name of city customer lives in';
      id_State     : P := 'Enter abbreviation for state customer lives in';
      id_ZipCode   : P := 'Enter customer''s zip code';
      id_HomePhone : P := 'Enter customer''s home phone number';
      id_WorkPhone : P := 'Enter customer''s work phone number';
      id_OK        : P := 'Accept customer information';
      id_Cancel    : P := 'Cancel all edits';
    end;

    {set text of help line}
    HelpLine^.SetText(P);
  end;

  procedure TCustomer.dwmHelp(var Msg : TMessage);
  var
    S : array[0..80] of Char;
  begin
    {get text of help line}
    HelpLine^.GetText(S, 80);

    {display message box}
    MessageBox(hWindow, S, 'Help', mb_IconQuestion);
  end;

End.